//GLOBAL VARS
var online = false;
var entriesMax = 50;
var entriesTotal;
var entriesPerPage = 25;
var feedUrl = "http://motor.levante-emv.com/rss-app";
var feedResult;
var feedDate;
var postId = 0; 
var listScroll = null;
var carouselScroll = null;
var articleScroll = null;
var noScreenModes = false;
var windowWidth;
var windowHeight;

google.load("feeds", "1");

//INIT FUNCTIONS
function onDocumentReady() {    
    $("#feed").bind("pageshow", function(){
        $('#carouselScroll').html("");
        if(carouselScroll != null){carouselScroll.destroy();carouselScroll = null;}
        if(articleScroll != null){articleScroll.destroy();articleScroll = null;}
        $("#post .ui-header").css("visibility", "visible");
        $("#post .ui-footer").css("visibility", "visible");
        $("h2.title").css("margin-top", "80px");

        if(listScroll != null){
            var pixels = -(postId*101);
            listScroll.scrollTo(0, pixels, 50);
            listScroll.refresh();
        }
    });
    $('ul#listFeed').delegate("a","click",function(){
        postId = $(this).attr('data');
        $.mobile.changePage("#post", "pop", false, true);
        loadcarouselFeed();
    });
    $('#status').bind('marquee', function() {
        var tw = $(this).width();
        var ww = $(this).parent().width();
        $('#status .date').html(friendlyDate(feedDate));
        $(this).css({ right: -tw });
        $(this).animate({ right: ww }, 20000, 'linear', function() {
            $(this).trigger('marquee');
        });
    });
    
    $("#settings").bind("pageshow", function(){
        $("#entriesPerPage").val(entriesPerPage).slider("refresh");
        $("#feedUrl").val(feedUrl);
    });
    $("#reset").click(function(e) {
        if(typeof(Storage)!=="undefined"){window.localStorage.clear();}
        $(this).addClass("ui-disabled");
    });
    $('#samples').change(function() { 
        $("#feedUrl").val($(this).val());
        $(this).val('').selectmenu('refresh');
    });
    $("#settings").bind("pagehide", function(){        
        if($("#feedUrl").val()!="" && $("#feedUrl").val()!=feedUrl){
            feedUrl=$("#feedUrl").val();
            getData();
        }
        if($("#entriesPerPage").val()!=entriesPerPage){
            entriesPerPage=$("#entriesPerPage").val();            
            $('#listFeed li').css("display", "none");
            for(var i=0; i<entriesPerPage; i++){
                $('#listFeed li:hidden').first().css("display", "block");
            }
            listScroll.refresh();
            var entriesNum = $("#listFeed li:visible").length;
            $('#status .entries').text(entriesNum);
        }
        if(typeof(Storage)!=="undefined"){            
            window.localStorage.setItem("feedUrl", feedUrl);
            window.localStorage.setItem("entriesPerPage", entriesPerPage);
        }  
    });
    
    $("#carouselMask").on("taphold", function(event){
        if(noScreenModes == false){
            if($("#post .ui-header").css("visibility")=="hidden"){
                $("#post .ui-header").css("visibility", "visible");
                $("#post .ui-footer").css("visibility", "visible");
                $("h2.title").css("margin-top", "80px");
            }else{
                $("#post .ui-header").css("visibility", "hidden");
                $("#post .ui-footer").css("visibility", "hidden");
                $("h2.title").css("margin-top", "20px");
            }
        }
    });

    
    $("a[target='_blank']").click(function(event) {
        event.preventDefault();
        window.open($(this).attr("href"), "_system");
    });

    document.addEventListener("deviceready", onDeviceReady, false);
}
function onDeviceReady() {
    windowWidth = $(window).width();
    windowHeight = $(window).height();

    if(typeof(Storage)!=="undefined"){
        if (window.localStorage.getItem("feedUrl") == null){
            window.localStorage.setItem("entriesPerPage", entriesPerPage);
            window.localStorage.setItem("feedUrl", feedUrl);
        }else{
            entriesPerPage = parseInt(window.localStorage.getItem("entriesPerPage"));
            feedUrl = window.localStorage.getItem("feedUrl");
            feedResult = JSON.parse(window.localStorage.getItem("feedResult"));
            entriesTotal = parseInt(window.localStorage.getItem("entriesTotal"));
            feedDate = new Date(parseInt(window.localStorage.getItem("feedDate")));            
        }
    }else{
        $("#reset").addClass("ui-disabled");
    }

    if (navigator.connection.type == Connection.NONE){online  = false;}else{online = true;}
    document.addEventListener("online", function(){online = true;}, false);
    document.addEventListener("offline", function (){online = false;}, false);

    getData();
}

//DATA FUNCTIONS
function getData(){
    if (online) {
        try{getDataOnline();}catch(err){getDataOffline();}
    }else{
        getDataOffline();
    }
}
function getDataOnline(){
    var feed = new google.feeds.Feed(feedUrl);
    feed.setResultFormat(google.feeds.Feed.JSON_FORMAT);
    
    feed.setNumEntries(entriesMax); 
    feed.load(function(result) {
        if (!result.error) {
            $.mobile.showPageLoadingMsg('a', 'Descargando datos');
            feedResult = result;
            entriesTotal = result.feed.entries.length; 
            feedDate = new Date;
            window.localStorage.setItem("feedResult",JSON.stringify(result));
            window.localStorage.setItem("entriesTotal", entriesTotal);
            window.localStorage.setItem("feedDate", feedDate.getTime());
            $("#reset").removeClass("ui-disabled");
            loadlistFeed();
        }
    });
}
function getDataOffline(){
    if(typeof(Storage)!=="undefined"){
        if (window.localStorage.getItem("feedResult") != null){
            $.mobile.showPageLoadingMsg('a', 'Datos almacenados');
            loadlistFeed();
        }else{
            $.mobile.showPageLoadingMsg('a', 'No hay datos', true);
            setTimeout(function(){$.mobile.hidePageLoadingMsg();}, 2000);
        }
    }else{
        $.mobile.showPageLoadingMsg('a', 'Almacenamiento no disponible', true);
        setTimeout(function(){$.mobile.hidePageLoadingMsg();}, 2000);
    }
}

//FEED FUNCTIONS
function loadlistFeed(){
    setTimeout(function () {

        $('#listFeed').html("");

        for (var i = 0; i < entriesTotal; i++) {
            var entry = feedResult.feed.entries[i];
            var display = "";
            if (i>entriesPerPage-1) display="style='display: none;'";
            var html="<li "+ display + "><a data='" + i + "' >";
                if ("mediaGroups" in entry && entry.mediaGroups[0].contents[0].url!= undefined && online) {
                    html+="<div class='preload'><img src='"+entry.mediaGroups[0].contents[0].url+"'>"
                }else{
                    html+="<div class='noimage'>"
                }
                html+="<span class='friendlyDate'>" +friendlyDate(rssDateToObject(entry.publishedDate))+ "</span></div>";
                html+="<h3>"+ entry.title +"</h3>";
                html+="<p>"+ entry.contentSnippet +"</p>";
                html+="</a></li>";
            $('#listFeed').append(html);
        }
        var entriesNum = $("#listFeed li:visible").length;
        var html = "Visualizando <span class='entries'>"+entriesNum+"</span> entradas del canal <span class='title'>"+feedResult.feed.title+"</span> actualizado <span class='date'></span>";
        $('#status').html(html);
        $('#status').trigger('marquee');
        $.mobile.hidePageLoadingMsg();
        loadListScroll();
    }, 1000);
}
function loadcarouselFeed(){
    $.mobile.showPageLoadingMsg('a');
    setTimeout(function () {

        $('#carouselScroll').html("");

        for (var i = 0; i < entriesTotal; i++) {
            var entry = feedResult.feed.entries[i];
            var display = "";
            if (i==postId) {
                $('#link').attr('href', entry.link);
            }else{
                display="style='display: none;'";
            }
            var html="<div class='articleMask' id='" +i+ "' data='" +entry.link+ "'><article class='articleScroll'>";
                html+="<header>";
                html+="<h2 class='title'>" +entry.title+ "</h2>";
                html+="<div class='group'>";
                html+="<span>" +feedResult.feed.title+ "</span>";
                if (entry.author) html+=" | <span class='author'>" +entry.author+ "</span>";
                html+=" | <span class='date'>" +dateToSpanish(entry.publishedDate)+ "</span>";
                html+="</div>";
                html+="</header>";
                html+="<section class='content' " +display+ ">"+textFormatter(textCleaner(entry.content))+"</section>";
                html+="</article></div>";
            $('#carouselScroll').append(html);
        }
        loadCarouselScroll();
    }, 1000);
}

//SCROLL FUNCTIONS
function loadListScroll() {
    $('#listMask').css("visibility", "hidden");
    
    if(listScroll != null){listScroll.destroy();listScroll = null;}
    listScroll = new iScroll('listMask',{
        checkDOMChanges: true,
        useTransition: true,
        topOffset: $('#pullDown').height(),
        onScrollMove: function (){
            if (this.y > 5 && !$('#pullDown').hasClass('flip')) {
                $('#pullDown').addClass('flip');
                $('#pullDown .pullDownLabel').text('Suelte para refrescar...');
                this.minScrollY = 0;
            } else if (this.y < 5 && $('#pullDown').hasClass('flip')) {
                $('#pullDown').removeClass('flip');
                $('#pullDown .pullDownLabel').text('Deslice hacia abajo para refrescar...');
                this.minScrollY = -$('#pullDown').height();
            } else if (this.y < (this.maxScrollY - 5) && !$('#pullUp').hasClass('flip')) {
                $('#pullUp').addClass('flip');
                $('#pullUp .pullUpLabel').html('Suelte para cargar m&aacute;s...');
                this.maxScrollY = this.maxScrollY;
            } else if (this.y > (this.maxScrollY + 5) && $('#pullUp').hasClass('flip')) {
                $('#pullUp').removeClass('flip');
                $('#pullUp .pullUpLabel').html('Deslice hacia arriba para cargar m&aacute;s...');
                this.maxScrollY = $('#pullUp').height();
            }
        },
        onScrollEnd: function (){
            if ($('#pullDown').hasClass('flip')) {
                $('#pullDown').removeClass('flip');
                $('#pullDown').addClass('loading');
                $('#pullDown .pullDownLabel').text('Cargando datos...');
                setTimeout(function () {
                    getData();
                    $('#pullDown').removeClass('loading');
                    $('#pullDown .pullDownLabel').text('Deslice hacia abajo para refrescar...');
                }, 2000);
            } else if ($('#pullUp').hasClass('flip') && entriesPerPage < entriesTotal) {
                $('#pullUp').removeClass('flip');
                $('#pullUp').addClass('loading');
                $('#pullUp .pullUpLabel').text('Cargando datos...');
                setTimeout(function () {
                    for(var i=0; i<5; i++){
                        $('#listFeed li:hidden').first().css("display", "block");
                        entriesPerPage++;
                    }
                    listScroll.refresh();
                    if(typeof(Storage)!=="undefined"){window.localStorage.setItem("entriesPerPage", entriesPerPage);} 
                    var entriesNum = $("#listFeed li:visible").length;
                    $('#status .entries').text(entriesNum);
                    $('#pullUp').removeClass('loading');
                    $('#pullUp .pullUpLabel').html('Deslice hacia arriba para cargar m&aacute;s...');
                }, 2000);
            }
        }
    });
    $('#listMask').css("visibility", "visible");
}
function loadCarouselScroll() {
    windowWidth = $(window).width();
    windowHeight = $(window).height();
    $("#carouselMask").width(windowWidth);
    $("#carouselMask").height(windowHeight);
    $("#carouselMask").css("visibility", "hidden");
    $('#carouselScroll').width(windowWidth * entriesTotal);
    $('#carouselScroll').height(windowHeight);
    $('.articleMask').width(windowWidth);
    $('.articleMask').height(windowHeight);
    if(carouselScroll != null){carouselScroll.destroy();carouselScroll = null;}
    setTimeout(function () {
        carouselScroll = new iScroll('carouselMask', {
            snap: true,
            snapThreshold: Math.abs(windowWidth / 3),
            checkDOMChanges: false,
            momentum: false,
            hScrollbar: false,
            vScrollbar: false,
            lockDirection:true,
            onScrollMove: function () {
                noScreenModes = true;
            },
            onScrollEnd: function () {
                var newPostId = Math.abs(this.x / windowWidth);
                if(newPostId!=postId){
                    postId = newPostId;
                    $("div[id='"+postId+"'] .content").css("display", "block");
                    var link = $("div[id='"+postId+"']").attr('data');
                    $('#link').attr('href', link); 
                    $.mobile.showPageLoadingMsg('a');
                    noScreenModes = true;
                    loadArticleScroll();
                }
            }
        });
        carouselScroll.scrollToPage(postId, 0, 0);
        $("#carouselMask").css("visibility", "visible");
        carouselScroll.refresh();
        $.mobile.hidePageLoadingMsg();
        loadArticleScroll();
    }, 3000);
}

function loadArticleScroll() {
    if(articleScroll != null){articleScroll.destroy();articleScroll = null;}
    setTimeout(function () {
        articleScroll = new iScroll(postId,{
            checkDOMChanges: true,
            hScrollbar: false,
            vScrollbar: false,
            lockDirection:true,
            onScrollMove: function () {
                noScreenModes = true;
            },
            onScrollEnd: function () {
                noScreenModes = false;
            }
        });
        $.mobile.hidePageLoadingMsg();
    }, 500);
    noScreenModes = false;
}

//DATE FUNCTIONS
function getDateHour(){
    var date = new Date;
    var day = date.getDate();
    var month = date.getMonth();
    var year = date.getFullYear();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    if (hours <10) hours = "0" +hours;
    if (minutes <10) minutes = "0" +minutes;
    return hours+":"+minutes+", "+day+' de '+getMonthName(month)+' de '+year;
}
function getMonthName(monthNumber){
    var monthNames = ["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"];
    return monthNames[monthNumber];
}
function dateToSpanish(dateEn){       
    var dateEs = "";
    var monthsEn = ["Jan","Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    var monthsEs = ["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"];
    var daysEn = ["Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun"];
    var daysEs = ["Lunes", "Martes", "Mi&eacute;rcoles", "Jueves", "Viernes", "S&aacute;bado", "Domingo"];
    var dateEn = dateEn.substring(0,16);    
    for(var i=0; i<=11; i++){
        var date = dateEn.replace(monthsEn[i],"de "+monthsEs[i]+" de");
        if (date!=dateEn){
            dateEs=date;
            break;
        }
    }    
    for(var i=0; i<=6; i++){
        var date = dateEs.replace(daysEn[i],daysEs[i]);
        if (date!=dateEs){
            dateEs=date;
            break;
        }
    }    
    dateEs = dateEs.replace(" 0"," ");
    return dateEs;
}
function rssDateToObject(date){    
    var monthsEn = ["Jan","Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];    
    var dateString = date.substring(5,25);    
    dateString = dateString.replace(/:/g," ");    
    for(var i=0; i<=11; i++){
        var n = date.search(monthsEn[i]);
        if (n!=-1){
            dateString = dateString.replace(monthsEn[i], i);
            break;
        }
    }    
    dateString = dateString.replace(" 0"," ");    
    var dateArray = dateString.split(" ");
    var year = dateArray[2];
    var month = dateArray[1];
    var day = dateArray[0];
    var hours = dateArray[3];
    var minutes = dateArray[4];
    var seconds = dateArray[5];    
    var dateObject = new Date(year, month, day, hours, minutes, seconds)
    return dateObject;
}
function friendlyDate(date){    
    var nowDate = new Date();
    var pubDate = date;
    var elapsed = nowDate.getTime() - pubDate.getTime();
    var years = Math.floor(elapsed / (1000 * 60 * 60 * 24 * 365));
    if(years >=1){
        return "hace "+years+" a&ntilde;os";
    }else{
        var months = Math.floor(elapsed / (1000 * 60 * 60 * 24 * 31));
        if(months >=1){
            return "hace "+months+" meses";
        }else{
            var days = Math.floor(elapsed / (1000 * 60 * 60 * 24));
            if(days >=1){
                return "hace "+days+" d&iacute;as";
            }else{
                var hours = Math.floor(elapsed / (1000 * 60 * 60));
                if(hours >=1){
                    return "hace "+hours+" horas";
                }else{
                    var minutes = Math.floor(elapsed / (1000 * 60));
                    if(minutes >=1){
                        return "hace "+minutes+" minutos";
                    }else{
                        return "hace un momento";
                    }
                }
            }
        }
    }
}

//TEXT FUNCTIONS
function textCleaner(text){    
    var cleanText = text.replace(/\[youtube\]/g,"<a rel='external' href='");
    cleanText = cleanText.replace(/\[\/youtube\]/g,"'>Ver video</a>");
    
    cleanText = cleanText.replace(/\[nggallery id=[0-9]+\]/g, "");
    return cleanText;
}
function textFormatter(text){    
    var formattedText;
    if(text.indexOf("<p><img")==-1){
        formattedText = text.replace(/<p>/g,"");
        formattedText = formattedText.replace(/<\/p>/g,"<br><br>");
    }else{
        formattedText = (text.split('\n')).join("<br>");
        formattedText = formattedText.replace(/<br><br><br><br>/g,"<br><br>");
        if(online==false) {formattedText = formattedText.replace(/src/g,"data");}
    }
    formattedText = formattedText + "<br><br><br><br>&nbsp;<br><br><br><br>&nbsp;<br><br><br><br>";
    return formattedText;
}

//ASPECT FUNCTION
$(window).resize(function() {
    var currentPage = $('.ui-page-active').attr('id');
    if (currentPage == "post"){
        if (carouselScroll != null){
            windowWidth = $(window).width();
            windowHeight = $(window).height();
            $("#carouselMask").width(windowWidth);
            $("#carouselMask").height(windowHeight);
            $('#carouselScroll').width(windowWidth * entriesTotal);
            $('#carouselScroll').height(windowHeight);
            $('.articleMask').width(windowWidth);
            $('.articleMask').height(windowHeight);
            carouselScroll.refresh();
            carouselScroll.scrollToPage(postId, 0, 0);
            articleScroll.refresh();
        }
        else{
            loadCarouselScroll();
        }
    }
});